						.Code

						ALIGN	4

;	================================================================================
;	The smallest block the function can allocate is 4096 bytes
;	================================================================================

Memory_Alloc			PROC	__dwSize:DWord

						mov		eax,__dwSize
						add		eax,4095
						shr		eax,12			; Divide by 4096 (Alignment size)
						shl		eax,12			; Multiply by 4096

						INVOKE	VirtualAlloc,NULL,eax,MEM_COMMIT or MEM_RESERVE,PAGE_EXECUTE_READWRITE

						test	eax,eax
						ret
Memory_Alloc			ENDP

;	========================================================================================================================

Memory_Free				PROC	__lpBuffer:LPBYTE

						INVOKE	VirtualFree,__lpBuffer,0,MEM_RELEASE

						ret
Memory_Free				ENDP

;	========================================================================================================================
